SystemOrganization addCategory: #'StashShell-Core-Shell'!

PPCompositeParser subclass: #StashArgsParser
	instanceVariableNames: 'options option literal keywordOption'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 14:47'!
keywordOption

	^ (($- asParser , #letter asParser plus) flatten , literal optional) plus! !

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 14:47'!
literal

	^ (#word asParser plus) token trim ==> [:token | token value ]! !

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 14:47'!
option

	^ literal plus! !

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 14:47'!
options
	^ (keywordOption optional , option optional , keywordOption optional) optional
		==> [ :optionArray | 
			| flattenedOptions |
			flattenedOptions := OrderedCollection new.
			(optionArray select: [ :each | each ~~ nil ]) do: [ :each | 
				each isArray
					ifTrue: [ 
						(each select: [ :a | a ~~ nil ]) do: [:arg |
							arg isArray 
								ifTrue: [ flattenedOptions addAll: (arg select: [ :a | a ~~ nil ]) ]
								ifFalse: [ flattenedOptions add: arg ] ] ]
					ifFalse: [ flattenedOptions add: each ] ].
			flattenedOptions asArray ]! !

!StashArgsParser methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:47'!
start

	^options end! !

PPCompositeParser subclass: #StashCommandParser
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashCommandParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 11:07'!
command

	^(#letter asParser , #word asParser star) token trim ==> [ :token | token value ]! !

!StashCommandParser methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:59'!
start

	^command and! !

Object subclass: #StashCommand
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

StashCommand subclass: #StashBuiltInCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

StashBuiltInCommand subclass: #StashLSCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashLSCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/9/2010 15:07'!
executeIn: anEnvironment withArgs: argsString

	| args |
	args := self parser parse: argsString.
	args isEmpty
		ifTrue: [ 
			^anEnvironment currentWorkingNode listContents ].
	self halt! !

!StashCommand classSide methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/9/2010 14:12'!
command: commandName
	^(self new)
		command: commandName;
		yourself! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 13:56'!
command
	^ command! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 13:56'!
command: anObject
	command := anObject! !

!StashCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/9/2010 14:18'!
executeIn: anEnvironment withArgs: args

	self subclassResponsibility! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:08'!
parser

	^StashArgsParser new! !

Object subclass: #StashNode
	instanceVariableNames: 'name parent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:32'!
children

	children ifNil: [ children := Dictionary new ].
	^ children! !

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:31'!
children: anObject
	children := anObject! !

!StashNode methodsFor: 'builtIn commands' stamp: 'DaleHenrichs 12/9/2010 14:24'!
listContents

	self subclassResponsibility! !

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:25'!
name
	^ name! !

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:25'!
name: anObject
	name := anObject! !

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:30'!
parent

	^parent! !

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:30'!
parent: anObject
	parent := anObject! !

StashNode subclass: #StashRootNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashRootNode methodsFor: 'builtIn commands' stamp: 'DaleHenrichs 12/9/2010 14:34'!
listContents

	| stream |
	stream := WriteStream on: String new.
	stream
		nextPutAll: '.'.
	self children keysAndValuesDo: [:childName : child |
		stream cr; nextPutAll: childName ].
	^stream contents! !

!StashRootNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:28'!
name
	name ifNil: [ name := '/' ].
	^ name! !

Object subclass: #StashShell
	instanceVariableNames: 'parser promptString executableCommands rootNode currentWorkingNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashShell classSide methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/9/2010 10:05'!
open
	"self open"

	^ self new open! !

!StashShell methodsFor: 'node accessing' stamp: 'DaleHenrichs 12/9/2010 14:29'!
currentWorkingNode
	currentWorkingNode ifNil: [ currentWorkingNode := self rootNode ].
	^ currentWorkingNode! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 10:04'!
defaultPromptString

	^ '$ '! !

!StashShell methodsFor: 'input character filtering' stamp: 'DaleHenrichs 12/9/2010 10:14'!
doEndOfFile
	"EOF character detected."
! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:18'!
executableCommands

	executableCommands ifNil: [ executableCommands := Dictionary new.
		executableCommands at: #ls put: (StashLSCommand command: #ls). ].
	^executableCommands! !

!StashShell methodsFor: 'input character filtering' stamp: 'DaleHenrichs 12/9/2010 10:15'!
filterAndForwardEvent: keyboardEvent 
	"Filter keyboardEvent, taking special action if needed. If a child process
	is active, forward keyboardEvent to the child and answer nil. Otherwise
	answer keyboardEvent."

	^ keyboardEvent! !

!StashShell methodsFor: 'initialize-release' stamp: 'DaleHenrichs 12/9/2010 10:06'!
open

	| tty |
	tty := StashShellTranscriptStream stashShell: self.
	tty open.
	^ tty

! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 10:41'!
parser

	parser ifNil: [ parser := StashCommandParser new ].
	^parser! !

!StashShell methodsFor: 'evaluation' stamp: 'DaleHenrichs 12/9/2010 15:05'!
processCommand: aCommandString
	"parse and execute the command in aCommandString"

	| result command args executor |
	result := self parser parse: aCommandString.
	result isPetitFailure
		ifTrue: [ ^ 'command parse failure: ' , aCommandString printString ].
	command := result.
	args := (aCommandString copyFrom: result size + 1 to: aCommandString size) withBlanksTrimmed.
	executor := self executableCommands at: command ifAbsent: [ ^ 'The command ' , command printString , ' was not found' ].
	^ executor executeIn: self withArgs: args! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 10:04'!
promptString
	"The primary command prompt string, equivalent to $PS1 in a Unix shell"

	^ promptString ifNil: [promptString := self defaultPromptString]
! !

!StashShell methodsFor: 'node accessing' stamp: 'DaleHenrichs 12/9/2010 14:29'!
rootNode
	rootNode ifNil: [ rootNode := StashRootNode new ].
	^ rootNode! !
